# REBER Grammar automaton
# http://www.willamette.edu/~gorr/classes/cs449/reber.html#top
#
# UNARY = {0,1,2} output control
# -vno=N generated words
# -vP=p probability for reber words, if not given p=1
#

BEGIN {

  T["B"] = "TP"
  T["T"] = "SX"
  T["S"] = "SX"
  T["P"] = "tV"
  T["t"] = "tV"
  T["V"] = "vp"
  T["p"] = "xs"
  T["v"] = "E"
  T["X"] = "xs"
  T["x"] = "tV"       # T["x"] = "t" is the historic error
  T["s"] = "E"
  T["E"] = "0"


# after MDS on orthogonal data
# awk 'BEGIN{for(i=0;i<7;i++)for(j=0;j<7;j++) print i,j,(i==j)?0:1}' | ./mds_mat 7 5 .1

  if(UNARY > 1) {
    U["B"] = "-0.206556 0.536661 -0.064594 -0.086128 0.242735 0.165502"
    U["T"] = "-0.449839 -0.133558 -0.266214 0.014369 -0.319131 -0.188302"
    U["S"] = "0.163165 0.203213 0.420300 0.146222 -0.398398 -0.062441"
    U["P"] = "-0.047959 -0.176915 0.157456 0.359406 0.409798 -0.270319"
    U["V"] = "0.423025 0.001535 -0.442592 0.197866 -0.057610 0.106120"
    U["X"] = "0.200723 -0.095658 0.032678 -0.542943 0.090834 -0.273908"
    U["E"] = "-0.082561 -0.335277 0.162966 -0.088792 0.031771 0.523348"
  }
  else {
    U["B"] = "0 0 0 0 0 0 1"
    U["T"] = "0 0 0 0 0 1 0"
    U["S"] = "0 0 0 0 1 0 0"
    U["P"] = "0 0 0 1 0 0 0"
    U["V"] = "0 0 1 0 0 0 0"
    U["X"] = "0 1 0 0 0 0 0"
    U["E"] = "1 0 0 0 0 0 0"
  }

  C = "BTSPVXE"
  lC = length(C)

  if(P == "") P = 1.
  if(no <= 0) no = 100

  srand()

  do {

    if(rand() < P) {  ## stochastic decision: fake or real reber

      s = "B"

      while(s != "0") {

        if(UNARY) {
          print U[toupper(s)]
          if(++cnt >= no) break
        }
        else
          printf toupper(s)

        s = substr(T[s], int(rand() * length(T[s]) + 1), 1)
      }
    }
    else {  # fake reber

      do {
        z = .25 * (0.00119976 + (1 - 0.00119975) * rand())

        len = int(-log(z - .25 * 0.00119975) / 0.288901)

      } while(len <= 4)

      for(l = 0; l < len; l++) {

        s = substr(C, int(rand() * lC + 1), 1)

        if(UNARY) {
          print U[s]
          if(++cnt >= no) break
        }
        else
          printf s
      }
    }

    if(!UNARY) {
      print
      ++cnt
    }

  } while(cnt < no);
}
